import java.util.*;
import java.awt.*;
import java.applet.*;
import java.awt.event.*;

public class AButton extends Applet
  {
  private Font buttonFont=new Font("Helvetica",Font.PLAIN,10);
  private String buttonText,splitText[],buttonCommand;
  public int x,y,xl,yl,splitTextTotal;
  private Image gfx,pressedGfx;

  public AButton()
    {
    buttonText="";
    splitText=new String[10];
    buttonCommand=null;
    x=0;
    y=0;
    xl=0;
    yl=0;
    splitTextTotal=0;
    }

  public int getSplits()
    {
    return(splitTextTotal);
    }

  public String getSplit(int index)
    {
    return(splitText[index]);
    }

  public AButton(String name,String command,int x, int y)
    {
    buttonText=name;
    splitText=new String[10];
    buttonCommand=command;
    this.x=x;
    this.y=y;
    this.xl=100;
    this.yl=50;
    splitTextTotal=0;
    splitText();
    }

  public AButton(String name,String command,int x, int y,int xl, int yl)
    {
    buttonText=name;
    splitText=new String[10];
    buttonCommand=command;
    this.x=x;
    this.y=y;
    this.xl=xl;
    this.yl=yl;
    splitTextTotal=0;
    splitText();
    }

  public AButton(String name,String command,Image gfx,Image pressedGfx,int x, int y,int xl, int yl)
    {
    this.gfx=gfx;
    this.pressedGfx=pressedGfx;
    buttonText=name;
    splitText=new String[10];
    buttonCommand=command;
    this.x=x;
    this.y=y;
    this.xl=xl;
    this.yl=yl;
    splitTextTotal=0;
    splitText();
    }

  public AButton(String name,String command,Image gfx,int x, int y)
    {
    this.gfx=gfx;
    buttonText=name;
    splitText=new String[10];
    buttonCommand=command;
    this.x=x;
    this.y=y;
    this.xl=100;
    this.yl=50;
    splitTextTotal=0;
    splitText();
    }

  public AButton(String name,String command,Image gfx,Image pressedGfx,int x, int y)
    {
    this.gfx=gfx;
    this.pressedGfx=pressedGfx;
    buttonText=name;
    splitText=new String[10];
    buttonCommand=command;
    this.x=x;
    this.y=y;
    this.xl=100;
    this.yl=50;
    splitTextTotal=0;
    splitText();
    }

  public void splitText()
    {
    StringTokenizer data=new StringTokenizer(buttonText," ");
    String holder;
    splitText[0]=new String();
    while(data.hasMoreTokens())
      {
      holder=data.nextToken();
      if(splitText[splitTextTotal].length()+holder.length()>20)
        splitText[++splitTextTotal]=new String();
      splitText[splitTextTotal]+=holder+" ";
      }
    }

  public String getName()
    {
    return(buttonText);
    }

  public String getCommand()
    {
    return(buttonCommand);
    }

 public void drawButton(Graphics g,boolean pressed)
    {
    g.setFont(buttonFont);
    int fontXCent=x+xl/2,
        fontY=
          (
          y//The Y position
          +
          (yl/2)//half of the Y Length, so now we are at the middle of the box
          -
          ((g.getFontMetrics().getHeight()*splitTextTotal)/2))//Number of lines in pixels/2
          +
          (int)(g.getFontMetrics().getHeight()/3);//1/3 of a line, to fine tune it
    if(gfx==null)
      {
      g.setColor(Color.blue);
      g.fillRect(x,y,xl,yl);
      g.setColor(Color.white);
      g.drawRect(x,y,xl,yl);
      g.setColor(Color.cyan);
      }
      else
      {
      if(pressed)
        g.drawImage(pressedGfx,x-10,y-5,120,60,this);
        else
        g.drawImage(gfx,x,y,this);
      g.setColor(new Color(255,255,255));
      }

    for(int line=0;line<=splitTextTotal;line++)
      {
      drawCentre(g,splitText[line],fontXCent+2,fontY);
      fontY+=(int)(g.getFontMetrics().getHeight()/1.5);
      }
    }

  public void drawCentre(Graphics g,String s,int x,int y)
    {
    int newX=x-(g.getFontMetrics().stringWidth(s)/2);
    g.drawString(s,newX,y);
    }

  }