/*

*/

import java.awt.*;
import java.awt.event.*;
import java.applet.*;
import javax.swing.*;
import com.borland.jbcl.layout.*;
import java.awt.image.*;
import java.util.*;
//import java.lancs.*;

public class Till extends JApplet implements ActionListener
  {
	private ViewWindow viewWindow=null;
  private int sizeX,sizeY,buttonPressedTimer=0;
  private boolean buttonPressed=false;
  public static final int _DISP_currentOrders=0, _DISP_newOrder=1;
  private int stage=_DISP_currentOrders,actionCount=0;
  private TillNetworkCore server;
  private BufferedImage bufferImage=new BufferedImage(715,520,BufferedImage.TYPE_INT_RGB);
  private Graphics bufferImageHandle=bufferImage.getGraphics();
  private CurrentOrderDisplay currentOrderDisplay= new CurrentOrderDisplay();
  private NewOrderDisplay newOrderDisplay= new NewOrderDisplay();
  private AnOrder tillOrder=new AnOrder();
  private BarCodeReader BCR=new BarCodeReader();
  private RawDataHandler  completeDrinkList,
                          completeMainMealList,
                          completeSideOrderList,
                          completeDessertList,
                          completeItemList;

  private Timer timer;
  private String title="MAIN MENU",buttonMessage;
  private ButtonWindow  buttonDisplay,
                        mainMenu        = new ButtonWindow(),
                        addMenu         = new ButtonWindow(),
                        drinkMenu[]     = new ButtonWindow[10],
                        mainMealMenu[]  = new ButtonWindow[10],
                        sideOrderMenu[] = new ButtonWindow[10],
                        dessertMenu[]   = new ButtonWindow[10];

  public void keyMessage(char keyReceived)
    {
    BCR.addNextCharacter(keyReceived);
    if(BCR.orderFinished())
      server.sendMessage(BCR.getOrder());
    }

  public void removeReady(int x,int y)
    {
    x-=20;y-=50;
    int cursor=y/40;
    String ordID;
    if(cursor<0) cursor=0;
    if(cursor>4) cursor=4;
    currentOrderDisplay.setCursor(cursor);
    if(cursor==0)
      ordID=currentOrderDisplay.getOrderIDOne();
      else
      ordID=currentOrderDisplay.getOrderIDAtCursor();
    server.sendMessage("orderNotReady:"+ordID);
    server.getMessage();
    server.sendMessage("getCurrentOrderList");
    currentOrderDisplay.setMetaInformation(new RawDataHandler(server.getMessage()));
    refreshWindow();
    }

  public void mouseButtonMessage(MouseEvent e)
    {
    if(e.getY()<250) removeReady(e.getX(),e.getY());
    int buttonID=buttonDisplay.findButton(e.getX(),e.getY());
    if(buttonID==-1) return;
    System.out.println(buttonID);
    buttonPressed=true;buttonPressedTimer=1;
    buttonMessage=buttonDisplay.getMessage(buttonID);
    buttonDisplay.pressButton(bufferImageHandle,buttonID);
    //Draw the new button
    viewWindow.repaint();
    }

  public void processButton(String mouseMessage)
    {
    System.out.println(mouseMessage);
    String command,data;
    StringTokenizer mouseMessageParser=new StringTokenizer(mouseMessage,":");
    command=mouseMessageParser.nextToken();
    data=mouseMessageParser.nextToken();
    if(command.equals("NewMenu"))       displayNewMenu(data);
    if(command.equals("DrinksMenu"))    displayNewDrinkMenu(data);
    if(command.equals("MainMealMenu"))  displayNewMainMealMenu(data);
    if(command.equals("SideOrderMenu")) displaySideOrderMenu(data);
    if(command.equals("DessertMenu"))   displayDessertMenu(data);
    if(command.equals("AddAnItem"))     addAnItem(data);
    if(command.equals("DeleteAnItem"))  deleteAnItem();
    if(command.equals("SendOrder"))     sendOrder();
    }

  public void sendOrder()
    {
    String message="newOrder:",extras;
    //Table number, waitress number
//    message+= tillOrder.getTableID()+","+
//              tillOrder.getWaitressID();
    message+="0,8";
    for(int j=0;j<tillOrder.getNumberOfMeals();j++)
      {
      message+= ","+tillOrder.getMeal(j);
      extras=tillOrder.getExtras(j);
      if(!extras.equals("")) message+=","+extras;
      }
    tillOrder.deleteOrder();
    server.sendMessage(message);
    stage=_DISP_currentOrders;
    title="MAIN MENU";
    buttonDisplay=mainMenu;
    refreshWindow();
    }

  public void deleteAnItem()
    {
    tillOrder.deleteMeal();
    refreshWindow();
    }

  public void addAnItem(String itemID)
    {
    tillOrder.addMeal(itemID,"");
    refreshWindow();
    }

  public void displayDessertMenu(String page)
    {
    buttonDisplay=dessertMenu[Integer.parseInt(page)];
    refreshWindow();
    }

  public void displaySideOrderMenu(String page)
    {
    buttonDisplay=sideOrderMenu[Integer.parseInt(page)];
    refreshWindow();
    }

  public void displayNewDrinkMenu(String page)
    {
    buttonDisplay=drinkMenu[Integer.parseInt(page)];
    refreshWindow();
    }

  public void displayNewMainMealMenu(String page)
    {
    buttonDisplay=mainMealMenu[Integer.parseInt(page)];
    refreshWindow();
    }

  public void displayNewMenu(String menuName)
    {
    if(menuName.equals("AddOrder"))
      {
      stage=_DISP_newOrder;
      title="ADD ORDER";
      buttonDisplay=addMenu;
      refreshWindow();
      }

    if(menuName.equals("AmendOrder"))
      {
      title="AMEND ORDER";
      buttonDisplay=addMenu;
      refreshWindow();
      }

    if(menuName.equals("DeleteOrder"))
      {
      title="DELETE ORDER";
      buttonDisplay=addMenu;
      refreshWindow();
      }

    if(menuName.equals("AddDrink"))
      {
      title="ADD DRINK TO ORDER";
      buttonDisplay=drinkMenu[0];
      refreshWindow();
      }

    if(menuName.equals("AddMain"))
      {
      title="ADD MAIN MEAL TO ORDER";
      buttonDisplay=mainMealMenu[0];
      refreshWindow();
      }

    if(menuName.equals("AddDessert"))
      {
      title="ADD DESSERT TO ORDER";
      buttonDisplay=dessertMenu[0];
      refreshWindow();
      }

    if(menuName.equals("AddSideOrder"))
      {
      title="ADD SIDE ORDER TO ORDER";
      buttonDisplay=sideOrderMenu[0];
      refreshWindow();
      }

    if(menuName.equals("AddSpecial"))
      {
      title="ADD DRINK TO ORDER";
      buttonDisplay=addMenu;
      refreshWindow();
      }

    if(menuName.equals("Home"))
      {
      stage=_DISP_currentOrders;
      tillOrder.deleteOrder();
      title="MAIN MENU";
      buttonDisplay=mainMenu;
      refreshWindow();
      }
    }

  public void actionPerformed(ActionEvent e)
    {
    if(buttonPressed==true)
      if(--buttonPressedTimer==0)
        {
        processButton(buttonMessage);
        buttonPressed=false;
        }
    if(actionCount++==20)
      {
      actionCount=0;
      System.out.println("UPDATING SCREEN!");
      server.sendMessage("getCurrentOrderList");
      String raw=server.getMessage();
      currentOrderDisplay.setMetaInformation(new RawDataHandler(raw));
      refreshWindow();
      }
    }

  //Construct the applet
  public Till() throws Exception
    {
    server=new TillNetworkCore();
    server.sendMessage("getCurrentOrderList");
    String raw=server.getMessage();
    System.out.println("RAW=\n"+raw);
    currentOrderDisplay.setMetaInformation(new RawDataHandler(raw));
    }

  public void refreshWindow()
    {
    clearWindow();
    drawDisplay();
    drawButtons();
    viewWindow.repaint();
    }

  public void update(Graphics g)
    {
    paint(g);
    }

  public void paint(Graphics g)
    {
    System.out.println("REPAINTING!");
    viewWindow.paint(g);
    }

  public void clearWindow()
    {
    bufferImageHandle.setColor(new Color(0,20,0));
    bufferImageHandle.fillRect(0,0,715,520);
    }

  public void drawDisplay()
    {
    switch(stage)
      {
      case _DISP_currentOrders  : currentOrderDisplay.drawDisplay(bufferImageHandle);
                                  break;
      case _DISP_newOrder       : newOrderDisplay.drawDisplay(bufferImageHandle,tillOrder);
                                  break;
      }
    }

  public void drawButtons()
    {
    bufferImageHandle.setColor(new Color(50,70,50));
    bufferImageHandle.fill3DRect(10,280,695,220,true);//Draw the display background box
    bufferImageHandle.setColor(Color.green);
    bufferImageHandle.setFont(new Font("Helvetica",Font.BOLD,20));
    drawCentre(title,360,315,bufferImageHandle);
    buttonDisplay.drawAllButtons(bufferImageHandle);
    }

  public void makeButtons()
    {
    Image but1,but2;
    MediaTracker tracker=new MediaTracker(this);
    but1=getImage(getCodeBase(),"but1.gif");
    but2=getImage(getCodeBase(),"but5.gif");
    tracker.addImage(but1,0);
    tracker.addImage(but2,0);
    System.out.println("WAITING TO LOAD GFX!");
    try{tracker.waitForAll();}catch(Exception e){}
    System.out.println("LOADED!");

    //Setup the main menu display
    mainMenu.addButton("Dining Order","NewMenu:AddOrder",but1,but2,310,420);
    mainMenu.addButton("Amend Order","NewMenu:AmendOrder",but1,but2,310,350);
    mainMenu.addButton("Delete Order","NewMenu:DeleteOrder",but1,but2,450,350);
    mainMenu.addButton("Add Order","NewMenu:PayOrder",but1,but2,170,350);

    //The Dining order menu
    addMenu.addButton("Add Drink","NewMenu:AddDrink",but1,but2,100,330);
    addMenu.addButton("Add Main Item","NewMenu:AddMain",but1,but2,240,330);
    addMenu.addButton("Add Side Order","NewMenu:AddSideOrder",but1,but2,380,330);
    addMenu.addButton("Add Dessert","NewMenu:AddDessert",but1,but2,520,330);
    addMenu.addButton("Cancel","NewMenu:Home",but1,but2,310,420);
    addMenu.addButton("Delete Last Item","DeleteAnItem:null",but1,but2,100,420);
    addMenu.addButton("Order Entry Completed","SendOrder:null",but1,but2,520,420);


    completeDrinkList     = getInformation("getDrinkList");
    completeMainMealList  = getInformation("getMainMealList");
    completeSideOrderList = getInformation("getSideOrderList");
    completeDessertList   = getInformation("getDessertList");
    completeItemList      = getInformation("getMenuList");
    newOrderDisplay.setItemData(completeItemList);
    System.out.println("ITEMS FOUND:"+completeItemList.records);

    createMenuButtons(completeDrinkList,"NewMenu:AddOrder","DrinksMenu:","AddAnItem:",drinkMenu,but1,but2);
    createMenuButtons(completeMainMealList,"NewMenu:AddOrder","MainMealMenu:","AddAnItem:",mainMealMenu,but1,but2);
    createMenuButtons(completeSideOrderList,"NewMenu:AddOrder","SideOrderMenu:","AddAnItem:",sideOrderMenu,but1,but2);
    createMenuButtons(completeDessertList,"NewMenu:AddOrder","DessertMenu:","AddAnItem:",dessertMenu,but1,but2);

    buttonDisplay=mainMenu;
    }

  public RawDataHandler getInformation(String query)
    {
//Send the query
    server.sendMessage(query);
//Get the servers response
    String rawData=server.getMessage();
//Create a RawDataHandler for the search results
    return(new RawDataHandler(rawData));
    }

  public void createMenuButtons(RawDataHandler completeList,String cancelCommand,String menuName,String addCommand,ButtonWindow window[],Image but1,Image but2)
    {
    int x=0,                    //Start X offset button matrix
        y=0,                    //Start Y offset button matrix
        buttonsOnThisPage=0,    //Current page button count
        totalNumberOfButtons=0, //Total number of buttons
        pageNumber=0;           //Current page number
//Store the total number of items
    totalNumberOfButtons=completeList.records;
//Create a new instance of the ButtonWindow in the storage array
    window[0]=new ButtonWindow();
//Prepare to do all the buttons
    for(int button=0;button<totalNumberOfButtons;button++)
      {
//Add the next button to the current page
      window[pageNumber].addButton
        (
        completeList.getDataItem(button+1,"Name"),
        addCommand+completeList.getDataItem(button+1,"Item ID"),
        but1,but2,x+60,y+330
        );
//Increase the button counter, and move to the next button position
      buttonsOnThisPage++;
      x+=120; if(x>500) {x=0; y+=55;}
//If we have made a full page of buttons, or we have run out of buttons to place
      if(buttonsOnThisPage==10||button==totalNumberOfButtons-1)
        {
//Then add the cancel button
        window[pageNumber].addButton("Finished",cancelCommand,but1,but2,300,443);
//If this isn't the first page, also add the 'previous' button
        if(pageNumber>0)
          window[pageNumber].addButton("Previous",menuName+(pageNumber-1),but1,but2,60,443);
//If this isn't the last page, add the 'next' button
        if(button<totalNumberOfButtons-1)
          {
          window[pageNumber].addButton("Next",menuName+(pageNumber+1),but1,but2,540,443);
//Another page will also need to be created, as this one is full, and there are
//more buttons to place, so reset the X,Y positions, and create a new ButtonWindow object
          buttonsOnThisPage=0;x=0;y=0;
          window[++pageNumber]=new ButtonWindow();
          }//End if(button<totalNumberOfButtons-1)
        }//End if(buttonsOnThisPage==10||button==totalNumberOfButtons-1)
      }//End for(int button=0;button<totalNumberOfButtons;button++)
    }

  public void start()
    {
    if(timer==null)
      {
      System.err.println("Creating primary timer.");
      timer=new Timer(500,this);
      timer.start();
      }
    }

  //Initialize the applet
  public void init()
    {
    makeButtons();
    try
      {
      jbInit();
      }
    catch(Exception e)
      {
      e.printStackTrace();
      }
    refreshWindow();
    }

  //Component initialization
  private void jbInit() throws Exception
    {
    this.setSize(715,520);
		this.setBackground(Color.black);
		sizeX=getSize().width;
		sizeY=getSize().height;
    viewWindow=new ViewWindow();
		viewWindow.setSize(sizeX, sizeY);
		viewWindow.addKeyListener(new KeyGrab());
    viewWindow.addMouseListener(new MouseGrab());
		getContentPane().add(viewWindow);
  	viewWindow.requestFocus();
    }

  public void drawCentre(String s,int x,int y,Graphics g)
    {
    int newX=x-(g.getFontMetrics().stringWidth(s)/2);
    g.drawString(s,newX,y);
    }

  //Get Applet information
  public String getAppletInfo()
    {
    return "Applet Information";
    }

  // static initializer for setting look & feel
  static
    {
    try
      {
      UIManager.setLookAndFeel(UIManager.getSystemLookAndFeelClassName());
      //UIManager.setLookAndFeel(UIManager.getCrossPlatformLookAndFeelClassName());
      }
    catch (Exception e) {}
    }

	private final class ViewWindow extends java.awt.Canvas
  	{
		public ViewWindow(){}
		public void update(Graphics g) { g.drawImage(bufferImage, 0, 0, this); }
		public void paint(Graphics g) { g.drawImage(bufferImage, 0, 0, this);}
  	}

  private final class KeyGrab extends KeyAdapter
    {
    public KeyGrab(){}
  	public void keyTyped(KeyEvent e){keyMessage((char)e.getKeyChar());}
    }

  private final class MouseGrab extends MouseAdapter
    {
    public MouseGrab(){}
    public void mousePressed(MouseEvent e){mouseButtonMessage(e);}
    }

  }
