package Server;

public class MessagePacket
  {
  public int messageID;
  public String message,data;

  public MessagePacket(int ID, String message)
    {
    messageID=ID;
    this.message=message;
    data="";
    processCurrentPacket();
    }

  public MessagePacket(String message)
    {
    messageID=-1;
    this.message=message;
    data="";
    processCurrentPacket();
    }

  public MessagePacket(int ID)
    {
    messageID=ID;
    message="";
    data="";
    processCurrentPacket();
    }

  public MessagePacket()
    {
    messageID=0;
    message="";
    data="";
    }

  public MessagePacket newMessagePacket(int ID, String message)
    {
    messageID=ID;
    this.message=message;
    data="";
    processCurrentPacket();
    return this;
    }

  private void processCurrentPacket()
    {
    String temp;
    if(message.lastIndexOf(':')==-1)
      data="";
      else
      {
      temp=message.substring(0,message.lastIndexOf(':'));
      data=message.substring(message.lastIndexOf(':')+1,message.length());
      message=temp;
      }
    }
  }