package Server;

import java.sql.*;

public class ResultHandler
  {
  private ResultSetMetaData rsmd;
  private ResultSet rs;
  private int numOfColumns,numOfRows;
  private String result;

  public ResultHandler() {}

  public int getNumberOfResults()
    {
    return numOfRows;
    }

  public int getNumberOfColumns()
    {
    return numOfColumns;
    }

  public String getColumnName(int index)
    {
    try
      {
      return(rsmd.getColumnLabel(index));
      }
    catch(Exception e)
      {
      e.printStackTrace();
      return("");
      }
    }

  public String getResultSet()
    {
    return(result);
    }

  public String newResultSet(ResultSet prs) throws Exception
    {
    result="";
    rs=prs;
    rsmd=rs.getMetaData();
    numOfColumns=rsmd.getColumnCount();
    numOfRows=0;
    for(int i=1;i<=numOfColumns;i++) result+=(i>1?",":"")+rsmd.getColumnLabel(i);
    result+="\n";
    boolean more=rs.next();
    while(more)
      {
      numOfRows++;
      for(int i=1;i<=numOfColumns;i++) result+=(i>1?",":"")+rs.getString(i);
      result+="\n";
      more=rs.next();
      }
    prs.close();//Ensure the query is closed after use!
    return(numOfRows+"\n"+numOfColumns+"\n"+result);
    }

  }