import java.awt.*;

public class ButtonWindow
  {
  AButton button[];

  int buttonIndex;

  public ButtonWindow()
    {
    button=new AButton[100];
    buttonIndex=0;
    }

  public int findButton(int mx,int my)
    {
    int x,y,xl,yl;
    for(int index=0;index<buttonIndex;index++)
      {
      x=button[index].x;
      y=button[index].y;
      xl=button[index].xl;
      yl=button[index].yl;
      if(mx>x&&mx<x+xl&&my>y&&my<y+yl)
        return(index);
      }
    return(-1);
    }

  public void pressButton(Graphics g,int buttonID)
    {
    button[buttonID].drawButton(g,true);
    }

  public String getMessage(int index)
    {
    return(button[index].getCommand());
    }

  public void unpressButton(Graphics g,int buttonID)
    {
    button[buttonID].drawButton(g,false);
    }

  public void addButton(AButton newButton)
    {
    button[buttonIndex++]=newButton;
    }

  public void addButton(String name,String command,int x,int y)
    {
    button[buttonIndex++]=new AButton(name,command,x,y);
    }

  public void addButton(String name,String command,Image gfx,int x,int y)
    {
    button[buttonIndex++]=new AButton(name,command,gfx,x,y);
    }

  public void addButton(String name,String command,Image gfx,Image pressedGfx,int x,int y)
    {
    button[buttonIndex++]=new AButton(name,command,gfx,pressedGfx,x,y);
    }

  public void drawAllButtons(Graphics g)
    {
    for(int index=0;index<buttonIndex;index++)
      button[index].drawButton(g,false);
    }

  public void drawButtons(Graphics g,int index)
    {
    button[index].drawButton(g,false);
    }

  }