
import java.net.*;
import java.io.*;

//This class handles the low level initial communication between the client and the server.
//It connects, and allows messages to be sent and received as strings.

public class ClientNetworkCore
  {
  private static final boolean _LOCAL_HOST=true;

  InputStream input;
  OutputStream output;

  public String getMessage()
    {
    String message="";
    char c;
    try
      {
      while((c=(char)input.read())!=8)
        message+=String.valueOf(c);
      }
    catch(Exception e)
      {
      }
    String noRets="";
    for(int i=0;i<(message.length()>19?20:message.length());i++)
      {
      char d=message.charAt(i);
      if(d<32) d=32;
      noRets+=d;
      }
    System.out.println(" Response: "+noRets+(message.length()>19?"...":"")+"|");
    return(message);
    }

  public void sendMessage(String message)
    {
    System.out.print("MESSAGE SENT:"+message);
    try
      {
      for(int i=0;i<message.length();i++)
        output.write((int)message.charAt(i));
      output.write((int)8);
      }
    catch(Exception e)
      {
      }
    }

  public ClientNetworkCore(String thisClientsID)
    {
    boolean connected=false;
    int offsetID=514;
    String baseID="M210";
    Socket client=null;
    do
      {
      connected=true;
      try
        {
        if(_LOCAL_HOST)
          client=new Socket(InetAddress.getLocalHost(),5000);
          else
          {
          System.out.print("Asking computer "+baseID+(offsetID+1)+" for a connetion...");
          client=new Socket(InetAddress.getByName(baseID+(++offsetID)),5000);
          }
        }
      catch(Exception e)
        {
        System.out.println("Denied!");
        connected=false;
        }
      }
    while(!connected);
    System.out.print("Found Server!\nCreated Socket!\n");
    try
      {
      input=client.getInputStream();
      output=client.getOutputStream();
      }
    catch(Exception e)
      {
      }
    System.out.print("Created streams\n");
    System.out.print("The server has said: ");
    System.out.println(getMessage());
    System.out.println("\nSending ID as: "+thisClientsID);
    sendMessage(thisClientsID);
    System.out.println("Done!\n");
    //WAIT FOR READY SIGNAL...
    System.out.print("Waiting for server ready: ");
    System.out.println(getMessage());
    }

  }
