import java.util.*;

public class RawDataHandler
  {
  String metaLines[]=new String[100];
  String info[][]=new String[100][100];
  int metaLinesCounter=0;
  int records=0,fields=0;

  public RawDataHandler(String rawData)
    {
    int headerOffset=2;
    try
      {
   		StringTokenizer data=new StringTokenizer(rawData,"\n");
  		while(data.hasMoreTokens()) metaLines[metaLinesCounter++]=data.nextToken();
      records=Integer.parseInt(metaLines[0]);
      fields=Integer.parseInt(metaLines[1]);
      for(int recordIndex=0;recordIndex<records+1;recordIndex++)
        {
        StringTokenizer metaLineSubset=new StringTokenizer(metaLines[recordIndex+headerOffset],",");
        for(int fieldIndex=0;fieldIndex<fields;fieldIndex++)
          info[recordIndex][fieldIndex]=metaLineSubset.nextToken();
        }
      }
    catch(Exception e)
      {
      }
    System.gc();
    }

  public String getDataItem(int record,int field)
    {
    return(info[record][field]);
    }

  public String getDataItem(int record,String field)
    {
    for(int fieldIndex=0;fieldIndex<fields;fieldIndex++)
      if(info[0][fieldIndex].equals(field)) return(info[record][fieldIndex]);
    return("#NULL#");
    }
  }
